PROGRAM drive_cdfcor

! From CMUVM.BITNET!32ZEJ7N Fri Mar 03 08:25:31 EDT 1989
 
! Code converted using TO_F90 by Alan Miller
! Date: 2000-07-09  Time: 00:54:54
 
USE Best_rational
IMPLICIT NONE

REAL (dp)  :: x(16), pwr(101,15), ftble(101), t(202), wtble(101),  &
              uptbl(101), altbl(101), error(102), ertst(9), alc(101,16)
INTEGER    :: indup(101), indlw(101), indf(101)
INTEGER    :: i, idb, idbm, iflag, ind1, ind2, indlp, ione, iopt, iqmin, &
              it, iter, j, jj, jobnm,  &
              meq, meqa, meqdf, mineq, nclgr, nmpp1, nmppq, nread, nrwgr,  &
              num1, num2, num3, numdm, numgr, nump, numq, nwrit
REAL (dp)  :: anep1, anep2, aswp1, aswp2, deltk, epsq, ertol, four, one,  &
              qmin, sixtn, spcmn, ten, three, two, zero

! THE APPROXIMATION PROBLEMS RUN WITH THIS DEMONSTRATION DRIVER
! ARE AS FOLLOWS.  NOTE THAT P(1) MEANS THE FIRST NUMERATOR
! COEFFICIENT, WHILE P(1.0) (RESP. P(Z)) MEANS THE VALUE OF THE
! NUMERATOR AT 1.0 (RESP. AT Z), AND SIMILARLY FOR Q.

! IN JOB 1, THE GRID IS A 101 POINT EQUALLY SPACED SUBDIVISION OF
!   THE CLOSED INTERVAL (0.0,2.0).  F(Z) IS 1.0 FOR 0.0 <= Z <= 1.0,
!   UNDEFINED FOR 1.0 < Z < 1.2, AND 0.0 FOR 1.2 <= Z <= 2.0.
!   (P/Q)(Z) IS (P(1)+P(2)*Z)/(Q(1)+Q(2)*Z+Q(3)*Z**2).  WE REQUIRE
!   (P/Q)(Z) >= 0.9999 FOR 0.0 <= Z <= 0.3, (P/Q)(Z) >= 0.0 FOR
!   1.0 < Z <= 2.0, AND Q(Z) >= 1000.0*B**(-T) FOR ALL Z,
!   WHERE T IS THE NUMBER OF BASE B DIGITS IN THE MANTISSA OF
!   FLOATING POINT NUMBERS.  (THIS LAST REQUIREMENT IS USED IN THE
!   FIRST FOUR JOBS TO AVOID THE POSSIBILITY THAT A BAD DENOMINATOR
!   VALUE AT A POINT WHERE F IS UNDEFINED, SO THE DIFFERENTIAL
!   CORRECTION INEQUALITIES DO NOT PROVIDE ANY CONTROL ON THE
!   DENOMINATOR, MIGHT PREMATURELY TERMINATE THE PROGRAM.)

! IN JOB 2, THE GRID IS A 21 POINT EQUALLY SPACED SUBDIVISION OF
!   THE CLOSED INTERVAL (0.0,PI).  F(Z) IS 1.0 FOR 0.0 <= Z <= PI/2,
!   UNDEFINED FOR PI/2 < Z < 3*PI/5, AND 0.0 FOR 3*PI/5 <= Z
!   <= PI.  (P/Q)(Z) IS (P(1)+P(2)*COSZ+...+P(7)*COS6Z)/(Q(1)+Q(2)*Z+
!   ...+Q(8)*COS7Z).  THE WEIGHT FUNCTION (FOR WEIGHTED ERROR CURVE
!   APPROXIMATION) IS 0.5 FOR 0.0 <= Z <= PI/2, UNDEFINED FOR
!   PI/2 < Z < 3*PI/5, AND 1.0 FOR 3*PI/5 <= Z <= PI.
!   WE REQUIRE (P/Q)(Z) >= 0.0 FOR PI/2 < Z <= PI AND
!   Q(Z) >= 1000.0*B**(-T) FOR ALL Z.

! JOB 3 IS THE SAME AS JOB 2 EXCEPT THE GRID IS A 41 POINT EQUALLY
!   SPACED SUBDIVISION OF THE CLOSED INTERVAL (0.0,PI), AND WE USE
!   THE P/Q PRODUCED IN JOB 2 FOR INITIALIZATION.

! IN JOB 4 THE GRID IS THE SET OF ORDERED PAIRS (Z1,Z2) WHERE Z1
!   AND Z2 ARE NONNEGATIVE INTEGERS WITH Z1**2+Z2**2 <= 16.0.
!   F(Z1,Z2) IS SQRT(16.0-Z1**2-Z2**2).  (P/Q)(Z1,Z2) IS (P(1)+
!   P(2)*Z1**2+P(3)*Z2**2)/(Q(1)+Q(2)*(Z1*Z2)**2).  WE REQUIRE
!   Q(Z1,Z2) >= 1000.0*B**(-T) FOR ALL (Z1,Z2).

! IN JOB 5 THE GRID IS A 21 POINT EQUALLY SPACED SUBDIVISION OF THE
!   CLOSED INTERVAL (0.0,2.0).  F(Z) IS 1.0 FOR Z=0.0 AND 0.0 FOR
!   0.0 < Z <= 2.0.  (P/Q)(Z) IS P(1)/(Q(1)+Q(2)*Z).  THIS IS AN
!   EXAMPLE WHERE NO BEST APPROXIMATION EXISTS.

! JOB 6 IS THE SAME AS JOB 5 EXCEPT WE REQUIRE Q(Z) >= 10.0**(-7) ON
!   THE GRID.  HERE A BEST APPROXIMATION DOES EXIST.

! IN JOB 7 THE GRID IS A 101 POINT EQUALLY SPACED SUBDIVISION OF THE
!   CLOSED INTERVAL (0.0,2.0).  F(Z) IS 3.0/(1.0+Z) + G(Z), WHERE
!   G HAS VALUES 0.2, -0.2, 0.2, AND -0.2 AT Z = 0.0, 0.2, 1.0,
!   AND 2.0 RESPECTIVELY, AND G IS LINEAR BETWEEN THESE POINTS.
!   (P/Q)(Z) IS (P(1)+P(2)*Z)/(Q(1)+Q(2)*Z+Q(3)*Z**2).  THIS IS AN
!   EXAMPLE WHERE THE BEST APPROXIMATION IS DEGENERATE.

! IN JOB 8 THE GRID IS A 101 POINT EQUALLY SPACED SUBDIVISION OF
!   THE CLOSED INTERVAL (0.0,2.0), F(Z) IS EXP(Z) FOR ALL Z, AND
!   (P/Q)(Z) IS (P(1)+P(2)*Z+P(3)*Z**2)/Q(1).  WE REQUIRE Q(1)=1.0,
!   (P/Q)(1.0) = F(1.0), AND 2.0*P(3) >= 3.0.  THIS EXAMPLE
!   ILLUSTRATES THE USE OF EQUALITY CONSTRAINTS (INCLUDING AN
!   INTERPOLATORY CONSTRAINT) AND AN ADDITIONAL INEQUALITY
!   CONSTRAINT FROM OPTION 4.  NOTE THAT IT IS NOT NECESSARY TO
!   EXPLICITLY IMPOSE THE CONSTRAINT Q(1)=1.0 FOR (GENERALIZED)
!   POLYNOMIAL APPROXIMATION AS LONG AS NO CONSTRAINTS FROM
!   OPTION 4 HAVE NONZERO RIGHT SIDES, BUT IT MAKES LESS WORK FOR
!   THE LINEAR PROGRAMMING SUBROUTINE IF THE CONSTRAINT IS IMPOSED.

! JOB 9 IS THE SAME AS JOB 1 EXCEPT THAT THE CONSTRAINTS Q(Z) >=
!   1000.0*B**(-T) FOR ALL Z ARE REPLACED BY THE CONSTRAINTS Q(Z) >=
!   0.5 FOR ALL Z, AND THE CONSTRAINTS (P/Q)(Z) >= 0.9999 FOR
!   0.0 <= Z <= 0.3 ARE REPLACED BY THE CONSTRAINT P(1) =
!   (Q(1)+Q(2))/2.0 + 1.0.

! THE DATA CARDS NEEDED FOR THESE JOBS ARE AS FOLLOWS (WITH THE
! C IN THE FIRST COLUMN REPLACED BY BLANKS).
!   1    2    3    1  101
!     1011
!                0.0                 2.0
!   1    7    8    1   21
!    21011
!                0.0 3.141592653589793238
!   1    7    8    1   41
!   121011
!                0.0 3.141592653589793238
!   2    3    2    5    5
!     1001
!                0.0                 0.0                 4.0             4.0
!   1    1    2    1   21
!        0
!                0.0                 2.0
!   1    1    2    1   21
!        1
!                0.0                 2.0
!   1    2    3    1  101
!        0
!                0.0                 2.0
!   1    3    1    1  101
!        2
!   2    1
!                0.0                 2.0
!   1    2    3    1  101
!     1013
!   1    0
!                0.0                 2.0
!   0    0    0    0    0

! SET MACHINE DEPENDENT PARAMETERS FOR THE DEMONSTRATION DRIVER.
! SET INPUT AND OUTPUT UNIT NUMBERS.
nread = 5
nwrit = 6

! SET PRECISION DEPENDENT CONSTANTS.
one = 1.0_dp
zero = 0.0_dp
two = one + one
three = one + two
four = two + two
ten = four + four + two
sixtn = ten + three + three

! SET SPCMN=B**(-T), WHERE B IS THE BASE AND T IS THE NUMBER OF BASE B DIGITS
! IN THE MANTISSA.  SPCMN IS THE MINIMUM RELATIVE SPACING ABS((X1-X2)/X2)
! BETWEEN TWO SUCCESSIVE FLOATING POINT NUMBERS, SO IT IS THE SPACING BETWEEN
! TWO SUCCESSIVE FLOATING POINT NUMBERS IN THE CLOSED INTERVAL (0.1,1.0).
! WE ALSO HAVE SPCMN=10.0**(-T*(LOG10)(B))= 10.0**(-TNMAN), WHERE TNMAN IS
! THE BASE 10 EQUIVALENT OF THE LENGTH OF THE MANTISSA.
spcmn = EPSILON(one)

! SET THE ERROR NORM TEST TOLERANCE ERTOL=MAX(10.0**(-11),
! 1000.0*SPCMN).
ertol = spcmn * ten ** 3
IF (ertol-ten**(-11) < 0) THEN
  ertol = ten ** (-11)
END IF
! END OF SETTING MACHINE AND PRECISION DEPENDENT CONSTANTS FOR THE
! DEMONSTRATION DRIVER.

jobnm = 1
! SET THE ERROR NORMS COMPUTED WITH THE IBM 3090 AT CENTRAL MICHIGAN
! UNIVERSITY FOR COMPARISON PURPOSES.  THIS MACHINE HAS 14 BASE 16
! DIGITS IN DOUBLE PRECISION.
ertst(1) = 0.369559497889575D0
ertst(2) = 0.8792063120 * ten ** (-5)
ertst(3) = 0.54401686050 * ten ** (-4)
ertst(4) = 0.447875655532295D0
ertst(5) = 0.22 * ten ** (-13)
ertst(6) = 0.999998000 * ten ** (-6)
ertst(7) = 0.200000000000000D0
ertst(8) = 0.148781030293754D0
ertst(9) = 0.380060239141926D0

! READ NUMDM, NUMP=NUMBER OF COEFFICIENTS IN THE NUMERATOR,
! NUMQ=NUMBER OF COEFFICIENTS IN THE DENOMINATOR, NRWGR =
! NUMBER OF ROWS IN THE GRID, NCLGR=NUMBER OF COLUMNS IN THE GRID.
10 READ (nread,*) numdm, nump, numq, nrwgr, nclgr

nmpp1 = nump + 1
nmppq = nump + numq
IF (numdm == 0) THEN
! A DATA CARD WITH 0 FOR NUMDM IS USED AS A SIGNAL TO STOP.
  STOP
END IF
WRITE (nwrit,5100) jobnm
numgr = nrwgr * nclgr

! READ THE OPTION SWITCH IOPT.  INSTRUCTIONS FOR SETTING IT
! ARE IN THE INITIAL COMMENTS OF CDFCOR.
READ (nread,*) iopt

ione = iopt - (iopt/10) * 10

! IF THE ONES DIGIT OF IOPT IS > 1, READ THE NUMBER MEQ OF EQUALITY CONSTRAINTS
! AND THE NUMBER MINEQ OF EXTRA INEQUALITY CONSTRAINTS (NOT INCLUDING THE
! DENOMINATOR OR RESTRICTED RANGE CONSTRAINTS SET ELSEWHERE).
IF (ione > 1) THEN
  READ (nread,*) meq, mineq
END IF

! READ THE ENDPOINTS INTO ASWP1, ASWP2 IN THE ONE DIMENSIONAL CASE.
! IN THE TWO DIMENSIONAL CASE ASWP1, ASWP2 AND ANEP1, ANEP2 ARE THE COORDINATES
! OF THE LOWER LEFT AND UPPER RIGHT CORNERS OF THE GRID RESPECTIVELY.
IF (numdm <= 1) THEN
  READ (nread,*) aswp1, aswp2
ELSE
  READ (nread,*) aswp1, aswp2, anep1, anep2
END IF

! PUT THE GRID POINTS INTO T.
CALL stcomp(numdm, nrwgr, nclgr, aswp1, aswp2, anep1, anep2, t)

! SET UP PWR AND FTBLE.
i = 0
idbm = -1
idb = 0
20 i = i + 1
IF (i <= numgr) THEN
  idbm = idbm + 2
  idb = idb + 2
  
! COMPUTE THE BASIS FUNCTIONS AND F AND, IF NECESSARY,
! WTBLE, INDUP, UPTBL, INDLW, ALTBL, AND INDF.
! IN THE ONE DIMENSIONAL CASE THE COORDINATE WILL BE T(I),
! WHILE IN THE TWO DIMENSIONAL CASE THE COORDINATES WILL BE
! (T(IDBM),T(IDB)).
  SELECT CASE ( jobnm )
    CASE (    1)
      GO TO 30
    CASE (    2)
      GO TO 60
    CASE (    3)
      GO TO 60
    CASE (    4)
      GO TO 90
    CASE (    5)
      GO TO 30
    CASE (    6)
      GO TO 30
    CASE (    7)
      GO TO 30
    CASE (    8)
      GO TO 30
    CASE (    9)
      GO TO 30
  END SELECT
  
! INPUT OF BASIS FUNCTIONS FOR JOBS 1, 5, 6, 7, 8, AND 9.
  30 pwr(i,1) = one
  IF (nump > 1) THEN
    DO  j = 2, nump
      pwr(i,j) = (t(i)) ** (j-1)
    END DO
  END IF
  pwr(i,nmpp1) = one
  IF (numq > 1) THEN
    DO  j = 2, numq
      jj = nump + j
      pwr(i,jj) = (t(i)) ** (j-1)
    END DO
  END IF

  SELECT CASE ( jobnm )
    CASE (    1)
      GO TO 100
    CASE (    2)
      GO TO 100
    CASE (    3)
      GO TO 100
    CASE (    4)
      GO TO 100
    CASE (    5)
      GO TO 150
    CASE (    6)
      GO TO 150
    CASE (    7)
      GO TO 160
    CASE (    8)
      GO TO 170
    CASE (    9)
      GO TO 100
  END SELECT
  
! INPUT OF BASIS FUNCTIONS FOR JOBS 2 AND 3.
  60 pwr(i,1) = one
  IF (nump > 1) THEN
    DO  j = 2, nump
      pwr(i,j) = COS((j-1)*t(i))
    END DO
  END IF
  pwr(i,nmpp1) = one
  IF (numq > 1) THEN
    DO  j = 2, numq
      jj = nump + j
      pwr(i,jj) = COS((j-1)*t(i))
    END DO
  END IF
  GO TO 130
  
! INPUT OF BASIS FUNCTIONS FOR JOB 4.
  90 pwr(i,1) = one
  pwr(i,2) = t(idbm) ** 2
  pwr(i,3) = t(idb) ** 2
  pwr(i,4) = one
  pwr(i,5) = pwr(i,2) * pwr(i,3)
  GO TO 140
  
! INPUT OF F, INDF, DENOMINATOR LOWER BOUND, AND LOWER CONSTRAINTS
! FOR JOBS 1 AND 9, AND ADDITIONAL EQUALITY CONSTRAINT FOR JOB 9.
  100 num1 = 3 * (numgr-1) / 20 + 1
  num2 = (numgr-1) / 2 + 1
  num3 = 3 * (numgr-1) / 5 + 1

! IF I=1 SET THE DENOMINATOR LOWER BOUND FOR JOBS 1 AND 9 AND THE
! ADDITIONAL EQUALITY CONSTRAINT FOR JOB 9.  NOTE THAT THESE THINGS
! NEED BE SET ONLY ONCE IN ANY ONE JOB.
  IF (i <= 1) THEN
    IF (jobnm <= 1) THEN
      epsq = spcmn * ten ** 3
    ELSE
      epsq = one / two
      alc(1,1) = one
      alc(1,2) = zero
      alc(1,3) = -one / two
      alc(1,4) = -one / two
      alc(1,5) = zero
      alc(1,6) = one
    END IF
  END IF

! SET RESTRICTED RANGE CONSTRAINTS FOR JOBS 1 AND 9.
  IF (i <= num1) THEN
    IF (jobnm > 1) GO TO 110
    indf(i) = 1
    ftble(i) = one
    indlw(i) = 1
    altbl(i) = one - ten ** (-4)
    GO TO 20
  END IF
  IF (i > num2) GO TO 120
  110 indf(i) = 1
  ftble(i) = one
  indlw(i) = 0
  GO TO 20
  120 IF (i < num3) THEN
    indf(i) = 0
    indlw(i) = 1
    altbl(i) = zero
    GO TO 20
  END IF
  indf(i) = 1
  ftble(i) = zero
  indlw(i) = 1
  altbl(i) = zero
  GO TO 20
  
! INPUT OF F, INDF, DENOMINATOR LOWER BOUND, WEIGHT FUNCTION, AND
! LOWER CONSTRAINTS FOR JOBS 2 AND 3.
  130 num1 = (numgr-1) / 2 + 1
  num2 = 3 * (numgr-1) / 5 + 1
  epsq = spcmn * ten ** 3
  IF (i <= num1) THEN
    indf(i) = 1
    ftble(i) = one
    wtble(i) = one / two
    indlw(i) = 0
    GO TO 20
  END IF
  IF (i < num2) THEN
    indf(i) = 0
    indlw(i) = 1
    altbl(i) = zero
    GO TO 20
  END IF
  indf(i) = 1
  ftble(i) = zero
  wtble(i) = one
  indlw(i) = 1
  altbl(i) = zero
  GO TO 20
  
! INPUT OF F, INDF, AND DENOMINATOR LOWER BOUND FOR JOB 4.
  140 epsq = spcmn * ten ** 3
! WE USE 16.0001 INSTEAD OF 16.0 IN THE NEXT TEST TO AVOID TROUBLE
! DUE TO ROUND OFF ERROR.
  IF (t(idbm)**2+t(idb)**2-(sixtn+ten**(-4)) <= 0) THEN
    indf(i) = 1
    IF (sixtn-t(idbm)**2-t(idb)**2 > 0) THEN
      ftble(i) = SQRT(sixtn-t(idbm)**2-t(idb)**2)
      GO TO 20
    END IF
    ftble(i) = zero
    GO TO 20
  END IF
  indf(i) = 0
  GO TO 20
  
! INPUT OF F FOR JOBS 5 AND 6.  WE ALSO INPUT EPSQ HERE, ALTHOUGH
! IT IS NOT ACTUALLY USED IN JOB 5.
  150 IF (i <= 1) THEN
    ftble(i) = one
    epsq = ten ** (-7)
    GO TO 20
  END IF
  ftble(i) = zero
  GO TO 20
  
! INPUT OF F FOR JOB 7.
  160 num1 = (numgr-1) / 10 + 1
  num2 = (numgr-1) / 2 + 1
  IF (i <= num1) THEN
    ftble(i) = three / (one+t(i)) - two * t(i) + two / ten
    GO TO 20
  END IF
  IF (i <= num2) THEN
    ftble(i) = three / (one+t(i)) + t(i) / two - three / ten
    GO TO 20
  END IF
  ftble(i) = three / (one+t(i)) - four * t(i) / ten + (three+three ) / ten
  GO TO 20
  
! INPUT OF F AND EQUALITY CONSTRAINTS FOR JOB 8.  WE NEED SET ALC ONLY ONCE.
  170 ftble(i) = EXP(t(i))
  IF (i > 1) GO TO 20
  DO  j = 1, nump
    alc(1,j) = zero
    alc(2,j) = one
    alc(3,j) = zero
  END DO
  alc(1,nmpp1) = one
  alc(1,nmpp1+1) = one
  alc(2,nmpp1) = zero
  alc(2,nmpp1+1) = EXP(one)
  alc(3,nump) = -two
  alc(3,nmpp1) = zero
  alc(3,nmpp1+1) = -three
! END COMPUTING OF BASIS FUNCTIONS AND F.
  GO TO 20
END IF

CALL cdfcor(nump, numq, numgr, ftble, pwr, iopt, epsq, indlw, altbl, indup,  &
            uptbl, indf, wtble, meq, mineq, alc, meqa, x, error, qmin, iqmin, &
            iter,  indlp, iflag)
! CHECK THE OUTPUT.  FIRST MAKE SURE IFLAG IS NONPOSITIVE.
IF (iflag > 0) THEN
  WRITE (nwrit,5600)
ELSE
! CHECK TO SEE IF THE COMPUTED ERROR NORM IS CORRECT WITHIN ERTOL.
  IF (ABS(error(numgr+1)-ertst(jobnm)) <= ertol) THEN
    WRITE (nwrit,5700)
    
!**********MODIFICATION  IF A FULL PRINTOUT IS DESIRED EVEN IF THE
! PROGRAM SUCCEEDS, THE NEXT STATEMENT SHOULD BE GO TO 620
! OTHERWISE THE NEXT STATEMENT SHOULD BE GO TO 790
  ELSE
!**********END MODIFICATION
    
    WRITE (nwrit,5800) ertol
  END IF
END IF

WRITE (nwrit,5900) numdm

WRITE (nwrit,6000) nump, numq, numgr, nrwgr, nclgr

WRITE (nwrit,6100) iopt

! IF THE ONES DIGIT OF IOPT EXCEEDS 1, WRITE THE NUMBERS OF EQUALITY AND EXTRA
! INEQUALITY CONSTRAINTS, AND THE NUMBER OF REDUNDANT EQUALITY CONSTRAINTS.
IF (ione > 1) THEN
  meqdf = meq - meqa
  WRITE (nwrit,6200) meq, meqdf, mineq
END IF

IF (numdm /= 2) THEN
  WRITE (nwrit,6300) aswp1, aswp2
ELSE
  WRITE (nwrit,6400) aswp1, aswp2, anep1, anep2
END IF

! WRITE IFLAG AND INDLP.
WRITE (nwrit,6500) iflag, indlp

! WRITE THE DENOMINATOR MINIMUM AND THE INDEX OF THE POINT WHERE IT OCCURRED.
WRITE (nwrit,6600) qmin, iqmin

! WRITE ITER AND DELTK.
deltk = error(numgr+1)
WRITE (nwrit,6700) iter, deltk

! WRITE THE COEFFICIENTS OF THE NUMERATOR AND DENOMINATOR.
WRITE (nwrit,6800) (x(i),i = 1,nump)

WRITE (nwrit,6900) (x(i),i = nmpp1,nmppq)

! WRITE THE ERRORS.
WRITE (nwrit,7000)
DO  i = 1, nrwgr
  ind1 = 1 + (i-1) * nclgr
  ind2 = i * nclgr
  WRITE (nwrit,7100) (error(it),it = ind1,ind2)
END DO

jobnm = jobnm + 1
GO TO 10
STOP

5100 FORMAT (///' ***********THIS IS JOB NUMBER',i4)
5600 FORMAT (/' THE PROGRAM FAILED IN THE INITIALIZATION,',  &
              ' SO WE GIVE A FULL PRINTOUT.')
5700 FORMAT (/' THE PROGRAM HAS WORKED NORMALLY.')
5800 FORMAT (/' THE ERROR NORM WAS OFF BY MORE THAN',e12.2,  &
              '   SO WE GIVE A FULL PRINTOUT.')

5900 FORMAT (/' WE ARE DEALING WITH FUNCTIONS OF',i4,'   VARIABLES')
6000 FORMAT (/' P HAS',i4,'   COEFFICIENTS    Q HAS',i4,'   COEFFICIENTS'// &
              ' THE GRID HAS',i5,'   POINTS ARRANGED',i5, '   BY',i5)
6100 FORMAT (/' IOPT IS',i10)
6200 FORMAT (/' THERE ARE',i5,'  EQUALITY CONSTRAINTS OF WHICH',i5,  &
    '  ARE REDUNDANT'//' THERE ARE',i5, '  EXTRA INEQUALITY CONSTRAINTS')
6300 FORMAT (/' THE LEFT END POINT IS',e25.15,//  &
              ' THE RIGHT END POINT IS',e25.15)
6400 FORMAT (/' THE COORDINATES OF THE SW AND NE POINTS',' ARE'/2E25.15,  &
              '   AND'/2E25.15)
6500 FORMAT (/' IFLAG IS',i5,'     INDLP IS',i4)
6600 FORMAT (/' THE MINIMUM VALUE OF THE DENOMINATOR IS',e25.15/  &
              ' ACHIEVED AT GRID POINT',i5)
6700 FORMAT (/' THE ERROR NORM AFTER',i5,'   ITERATIONS',' IS',e25.15)
6800 FORMAT (/' THE COEFFICIENTS OF P ARE'/(/3E25.15))
6900 FORMAT (/' THE COEFFICIENTS OF Q ARE'/(/3E25.15))
7000 FORMAT (/' THE ERRORS ARE')
7100 FORMAT (/4E20.10)

END PROGRAM drive_cdfcor
